/*! typed-dom v0.0.302 https://github.com/falsandtru/typed-dom | (c) 2016, falsandtru | (Apache-2.0 AND MPL-2.0) License */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["typed-dom"] = factory();
	else
		root["typed-dom"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 112:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.splice = exports.pop = exports.push = exports.shift = exports.unshift = exports.indexOf = void 0;

const global_1 = __webpack_require__(128);

function indexOf(as, a) {
  if (as.length === 0) return -1;
  return a === a ? as.indexOf(a) : as.findIndex(a => a !== a);
}

exports.indexOf = indexOf;

function unshift(as, bs) {
  if ('length' in as) {
    for (let i = as.length - 1; i >= 0; --i) {
      bs.unshift(as[i]);
    }
  } else {
    bs.unshift(...as);
  }

  return bs;
}

exports.unshift = unshift;

function shift(as, count) {
  if (count < 0) throw new Error('Unexpected negative number');
  return count === void 0 ? [as.shift(), as] : [splice(as, 0, count), as];
}

exports.shift = shift;

function push(as, bs) {
  if ('length' in bs) {
    for (let i = 0, len = bs.length; i < len; ++i) {
      as.push(bs[i]);
    }
  } else {
    for (const b of bs) {
      as.push(b);
    }
  }

  return as;
}

exports.push = push;

function pop(as, count) {
  if (count < 0) throw new Error('Unexpected negative number');
  return count === void 0 ? [as, as.pop()] : [as, splice(as, as.length - count, count)];
}

exports.pop = pop;

function splice(as, index, count, ...inserts) {
  if (count === 0 && inserts.length === 0) return [];
  count = count > as.length ? as.length : count;

  switch (index) {
    case 0:
      switch (count) {
        case 0:
          return [[], unshift(inserts, as)][0];

        case 1:
          return as.length === 0 ? [[], unshift(inserts, as)][0] : [[as.shift()], unshift(inserts, as)][0];

        case void 0:
          if (as.length > 1 || arguments.length > 2) break;
          return as.length === 0 ? [] : splice(as, index, 1);
      }

      break;

    case -1:
    case as.length - 1:
      switch (count) {
        case 1:
          return as.length === 0 ? [[], push(as, inserts)][0] : [[as.pop()], push(as, inserts)][0];

        case void 0:
          if (as.length > 1 || arguments.length > 2) break;
          return as.length === 0 ? [] : splice(as, index, 1);
      }

      break;

    case as.length:
    case global_1.Infinity:
      return [[], push(as, inserts)][0];
  }

  return arguments.length > 2 ? as.splice(index, count, ...inserts) : as.splice(index);
}

exports.splice = splice;

/***/ }),

/***/ 99:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.duffReduce = exports.duffEach = exports.duffbk = exports.duff = void 0;

function duff(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count % 8,
        d = (count - m) / 8;

    while (m--) {
      proc(i++);
    }

    while (d--) {
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
    }
  } else {
    let i = -count,
        m = i % 8,
        d = (i - m) / 8;

    while (m--) {
      proc(--i);
    }

    while (d--) {
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
    }
  }
}

exports.duff = duff;

function duffbk(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count % 8,
        d = (count - m) / 8;

    while (m--) {
      if (proc(i++) === false) return;
    }

    while (d--) {
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
      if (proc(i++) === false) return;
    }
  } else {
    let i = -count,
        m = i % 8,
        d = (i - m) / 8;

    while (m--) {
      if (proc(--i) === false) return;
    }

    while (d--) {
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
      if (proc(--i) === false) return;
    }
  }
}

exports.duffbk = duffbk;

function duffEach(array, proc) {
  let count = array.length;
  let i = 0,
      m = count % 8,
      d = (count - m) / 8;

  while (m--) {
    proc(array[i], i++, array);
  }

  while (d--) {
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
  }
}

exports.duffEach = duffEach;

function duffReduce(array, proc, initial) {
  let count = array.length;
  let i = 0,
      m = count % 8,
      d = (count - m) / 8;

  while (m--) {
    initial = proc(initial, array[i], i++, array);
  }

  while (d--) {
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
    initial = proc(initial, array[i], i++, array);
  }

  return initial;
}

exports.duffReduce = duffReduce;

/***/ }),

/***/ 128:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(921);

const global = void 0 || typeof globalThis !== 'undefined' && globalThis // @ts-ignore
|| typeof self !== 'undefined' && self || Function('return this')();
global.global = global;
module.exports = global;

/***/ }),

/***/ 921:
/***/ (() => {

 // @ts-ignore

var globalThis; // @ts-ignore

var global = (/* unused pure expression or super */ null && (globalThis));

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.querySelectorAll = exports.querySelector = void 0;

const duff_1 = __webpack_require__(99);

const array_1 = __webpack_require__(112);

function querySelector(node, selector) {
  return 'matches' in node && node.matches(selector) ? node : node.querySelector(selector);
}

exports.querySelector = querySelector;

function querySelectorAll(node, selector) {
  const acc = [];

  if ('matches' in node && node.matches(selector)) {
    acc.push(node);
  }

  return (0, duff_1.duffReduce)(node.querySelectorAll(selector), (acc, node) => (0, array_1.push)(acc, [node]), acc);
}

exports.querySelectorAll = querySelectorAll;
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});